
type expr =
    Funcall of expr * expr list
  | Int_Constant of int
  | Str_Constant of string
  | ID of string
  | Tuple of expr list
  | Stmt_Expr of stmt
  | Asign_Expr of expr * expr
  | Expr_Star of expr 
  | Array_Decl of expr * expr
  | Indirect_Ref of expr 
  | Array_Ref of expr * expr
and stmt =
    A_Stmt of expr 
  | IfStmt of expr * stmt list * (expr*stmt list) list * stmt list 
  | WhileStmt of expr * stmt list 
  | BlockStmt of stmt list
  | LoopStmt of stmt list
  | DeclVarStmtInit of expr * string * expr
  | DeclVarStmt of expr * string
  | ReturnStmt of expr
  | DeclFunc of expr * string * (expr*string) list * stmt list
  | DeclExtern of expr * string * (expr*string) list
  | ImportStmt

type program = stmt list    
